
/*
 *	portable.h
 *
 *	QNX 4
 *
 *	(C) Copyright 1993 by Robert Krten, all rights reserved.
 *
 *	This module contains portable type definitions for compiler independant
 *	typedef size definitions, and other byte-twiddling issues.
 *
 *	1993 08 29	R. Krten		created
*/

#ifndef	_PORTABLE_H_
#define	_PORTABLE_H_

#ifdef	__QNX__
typedef	unsigned char	U8;
typedef	signed char		S8;
typedef char			NATIVE_8;
typedef	unsigned short	U16;
typedef	signed short	S16;
typedef short			NATIVE_16;
typedef	unsigned long	U32;
typedef	signed long		S32;
typedef	long			NATIVE_32;

/*
 *	byte order within multi-byte constants, the _x represents significance,
 *	and the value of the constant represents memory byte offset
*/

#define	__PORTABLE_8_16_0	0		/* 16 bit, order = low / high */
#define	__PORTABLE_8_16_1	1

#define	__PORTABLE_16_32_0	0
#define	__PORTABLE_16_32_1	1

#define	__PORTABLE_8_32_0	0		/* 32 bit, order = lw/hw */
#define	__PORTABLE_8_32_1	1
#define	__PORTABLE_8_32_2	2
#define	__PORTABLE_8_32_3	3

#endif	/* __QNX__ */

/*
 *	derived types
*/

typedef U32 U64 [2];

/*
 *	Operating System Independant Constants
*/

#define	GET8_OF_16_L(n16)	(((NATIVE_8 *) &n16) [__PORTABLE_8_16_0])
#define	GET8_OF_16_H(n16)	(((NATIVE_8 *) &n16) [__PORTABLE_8_16_1])

#define	GET16_OF_32_L(n32)	(((NATIVE_16 *) &n32) [__PORTABLE_16_32_0])
#define	GET16_OF_32_H(n32)	(((NATIVE_16 *) &n32) [__PORTABLE_16_32_1])

#define	GET8_OF_32_LL(n32)	(((NATIVE_8 *) &n32) [__PORTABLE_8_32_0])
#define	GET8_OF_32_LH(n32)	(((NATIVE_8 *) &n32) [__PORTABLE_8_32_1])
#define	GET8_OF_32_HL(n32)	(((NATIVE_8 *) &n32) [__PORTABLE_8_32_2])
#define	GET8_OF_32_HH(n32)	(((NATIVE_8 *) &n32) [__PORTABLE_8_32_3])

#endif	/* _PORTABLE_H_ */

