
/*
 *	dir.c
 *
 *	QNX 4
 *
 *	(C) Copyright 1996 by Robert Krten, all rights reserved.
 *
 *	This module contains directory utilities.
 *
 *	1996 01 08	R. Krten		created
 *	1996 03 12	R. Krten		cleaned up for release
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>

#include "newslib.h"
#include "readdir.h"

extern	char	*progname;					/* main.c */
extern	char	*version;					/* version.c */

extern	int		optv;						/* main.c */

LPTRT *
readDir (directory, pattern)
char	*directory;
char	*pattern;
{
	LPTRT	*l;
	LPTRT	*orig;
	DIR		*dirp;
	struct	dirent *direntp;

	if (optv > 1) {
		printf ("readdir (%s, pattern %s)\n", directory, pattern);
	}

	if ((l = calloc (1, sizeof (LPTRT))) == NULL) {
		return (NULL);
	}

	orig = lptr;
	lptr = l;

	if ((dirp = opendir (directory)) != NULL) {
		lptrInit ('s');
		for (;;) {
			if ((direntp = readdir (dirp)) == NULL) {
				break;
			}
			if (optv > 1) {
				printf ("readdir:  %s\n", direntp -> d_name);
			}
			if (!fnmatch (pattern, direntp -> d_name, 0)) {
				lptrReader (direntp -> d_name);
			}
		}
		lptrSort ();
		closedir (dirp);
	}

	lptr = orig;

	if (dirp == NULL) {
		free (l);
		return (NULL);
	}

	return (l);
}

