
/*
 *	utils.c
 *
 *	QNX 4
 *
 *	(C) Copyright 1995 by Robert Krten, all rights reserved.
 *
 *	This module contains miscellaneous utility functions.
 *
 *	1995 12 22	R. Krten		created
 *	1996 03 12	R. Krten		cleaned up for release
*/

#include "newslib.h"

extern	char	*progname;					/* main.c */
extern	char	*version;					/* version.c */

extern	int		optv;						/* main.c -- verbose */

void
okToUnlink (fname)
char	*fname;
{
	char	buf [10];

	printf ("%s exists, unlink [y/N]?  ", fname);
	fflush (stdout);
	fgets (buf, 10, stdin);
	if (*buf != 'y') {
		exit (1);
	} else {
		unlink (fname);
	}
}

/*
 *	stringToStringArray (string, delimiters)
 *
 *	converts a "delimiters" separated list of elements (string) into a
 *	StringArrayT structure, which has an array of pointers into
 *	the individual string components, terminated by a pointer
 *	to a zero.
*/

StringArrayT *
stringToStringArray (s, b)
char	*s;
char	*b;		/* break string */
{
	StringArrayT	*sa;
	int		i;
	char	*ptr;

	if ((sa = calloc (1, sizeof (StringArrayT) + strlen (s))) == NULL) {
		fprintf (stderr, "%s:  out of memory in stringToStringArray (%d bytes)!\n", progname, sizeof (StringArrayT) + strlen (s));
		perror (NULL);
		exit (1);
	}
	strcpy (sa -> data, s);		/* save it */
	ptr = sa -> data;
	for (i = 0; i < MaxStringArrayPtrs; i++) {
		sa -> ptrs [i] = ptr;
		if (*ptr) {
			sa -> num = i + 1;
		}
		while (*ptr && strchr (b, *ptr) == NULL) {
			ptr++;
		}
		if (*ptr) {
			*ptr = 0;
			ptr++;
		}
	}
	return (sa);
}

int
sortStringArrayCompare (a, b)
char	**a;
char	**b;
{
	return (strcmp (*a, *b));
}

void
sortStringArray (sa)
StringArrayT *sa;
{
	qsort (sa -> ptrs, sa -> num, sizeof (char *), sortStringArrayCompare);
}

