
/*
 *	news.h
 *
 *	QNX 4
 *
 *	(C) Copyright 1995, 1996 by Robert Krten, all rights reserved.
 *
 *	This module contains all of the local includes and manifest constants
 *	for the NNTP news injection service of KNews.
 *
 *	1995 12 20	R. Krten		created
 *	1996 01 06	R. Krten		modified for VFsys-style
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>
#include <ctype.h>
#include <errno.h>
#include <utime.h>
#include <time.h>

#include <sys/types.h>

#include "../lib/portable.h"
#include "../lib/config.h"
#include "../lib/ipc.h"
#include "../lib/lptr.h"
#include "../lib/tcpip.h"
#include "../lib/getWord.h"
#include "../lib/nntp.h"
#include "../lib/utils.h"
#include "../lib/readdir.h"

/*
 *	Prototypes
*/

//	main.c
int			main (int, char **);
void		optproc (int, char **);

//	news.c
void		getNews (void);
void		doExpire (void);

//	active.c
void		activeErase (void);
void		activeEnder (void);
void		activeReadActive (LPTRT *, char *);
void		activeStarter (void);
void		activeWriteActive (LPTRT *, char *);
void		initializeDatabase (void);
int			incrementAndGetArticleNumber (char *);

//	filter.c
int			filterAcceptNewsgroup (char *);
void		filterStarter (void);
void		filterEnder (void);

