
/*
 *	database.h
 *
 *	QNX 4
 *
 *	(C) Copyright 1995, 1996 by Robert Krten, all rights reserved.
 *
 *	This module contains the manifest constants and structures used
 *	by the VFsys.knews database.
 *
 *	1995 12 23	R. Krten		created
 *	1996 01 04	R. Krten		VFsys-style
 *	1996 03 12	R. Krten		cleaned up for release
*/

typedef	struct dirNode_t
{
	char	*name;					/* of THIS node */

	struct	dirNode_t	*across;	/* pointer to associate (on same level) */
	struct	dirNode_t	*back;		/* pointer to previous associate (on same level) */
	struct	dirNode_t	*down;		/* pointer to descendants */
	struct	dirNode_t	*up;		/* pointer to parent */
	struct	fileNode_t	*files;		/* if any */
}	DirNodeT;

typedef struct fileNode_t
{
	U32		artnum;
	U32		expiry;
	U32		offset;
	U32		length;

	struct	fileNode_t	*next;
}	FileNodeT;

