
/*
 *	rm_news.c
 *
 *	QNX 4
 *
 *	(C) Copyright 1995 by Robert Krten, all rights reserved.
 *
 *	This module contains the resource manager sections that deal
 *	with news messages.
 *
 *	1995 12 28	R. Krten		created
 *	1996 01 05	R. Krten		updated for VFsys-style
 *	1996 01 08	R. Krten		added IPC debug message
 *	1996 02 18	R. Krten		added lseek/fstat
 *	1996 03 09	R. Krten		removed from resmgr.c
 *	1996 03 12	R. Krten		cleaned up for release
*/

#include "knews.h"

extern	char	*progname;					/* main.c */
extern	char	*version;					/* version.c */

extern	int		optv;						/* main.c, verbosity */
extern	MsgT	msg;						/* resmgr.c, global */
extern	int		createdFlag;				/* db_fsys.c, kludge flag, indicates that we created a newsgroup */

int
newsAddGroup (pid)
pid_t	pid;
{
pid=pid;
	if (optv > 1) {
		printf ("Told to add a group \"%s\"\n", msg.addnewsgroup.group);
	}
	mdMultiLevel (msg.addnewsgroup.group);
	if (createdFlag) {
		putGroupInfo (msg.addnewsgroup.group);
	}
	msg.addnewsgroup_reply.status = EOK;
	return (sizeof (msg.addnewsgroup_reply));
}

int
newsAddArticle (pid)
pid_t	pid;
{
	KNEWSAddArticleT	*art;
pid=pid;

	art = &msg.addarticle;
	msg.addarticle_reply.status = EOK;

	if (optv) {
		printf ("newsAddArticle group %s artnum %d expiry %d offset %d length %d\n",
			art -> group,
			art -> artnum,
			art -> expiry,
			art -> offset,
			art -> length);
	}

	if (putFileInfo (art -> group, art -> artnum, art -> expiry, art -> offset, art -> length) == NULL) {
		msg.addarticle_reply.status = ENOENT;
	} else {
		char	wmsg [BUFSIZ];

		sprintf (wmsg, "a %s %d %d %d %d\n", art -> group,
				 art -> artnum, art -> expiry,
				 art -> offset, art -> length);
		writeJournal (art -> expiry, wmsg);
	}
	return (sizeof (msg.addarticle_reply));
}

int
newsExpire (pid)
pid_t	pid;
{
pid=pid;
	if (optv) {
		printf ("newsExpire (at %d)\n", msg.expire.when);
	}
	databaseExpire (msg.expire.when);
	journalExpire (msg.expire.when);
	msg.expire_reply.status = EOK;
	return (sizeof (msg.expire_reply));
}

int
newsEraseDatabase (pid)
pid_t	pid;
{
pid=pid;
	if (optv) {
		printf ("newsEraseDatabase\n");
	}
	databaseEnder ();
	databaseStarter ();
	msg.erasedatabase_reply.status = EOK;
	return (sizeof (msg.erasedatabase_reply));
}

int
newsWriteDebug (pid)
pid_t	pid;
{
pid=pid;
	printf ("Writing debug info...\n");
	debugDumpDatabase ();
	msg.writedebug_reply.status = EOK;
	return (sizeof (msg.writedebug_reply));
}

